using GraphicsManager.Enums;
using GraphicsManager.Objects;
using GraphicsManager.Objects.Core;
using OpenTK.Mathematics;

namespace Luski.GUI.MainScreen.UI.SettingsPanel;

public class Category : UserControl
{
    private Label Top;
    private static FontInteraction? fi;
    private Rectangle line;
    public string Name
    {
        get => Top.Text;
    }

    public Category(string Name)
    {
        if (fi is null)
        {
            fi = Globals.DefaultFont.Clone();
            fi.FontSize = FontSize.Bold;
        }
        Top = new(fi)
        {
            Location = new((int)(5 * Globals.Settings.Scale), (int)(5 * Globals.Settings.Scale), 0),
            Text = Name
        };
        BackgroundColor = new(255, 255, 255, 0);
        base.Size = new((int)(307 * Globals.Settings.Scale), (int)(20 * Globals.Settings.Scale) + Top.Size.Y);
        Top.Location = new((base.Size.X - Top.Size.X) / 2, Top.Location.Y, 0);
        line = new()
        {
            Size = new(base.Size.X, (int)Globals.Settings.Scale),
            BackgroundColor = Color4.Gray,
            Location = new(0, base.Size.Y - (int)Globals.Settings.Scale, 0)
        };
        line.ForceDistanceUpdate(this);
        Controls.Add(line);
        Controls.Add(Top);
    }

    public void AddButton(CategoryButton cb)
    {
        Controls.Add(cb);
        int f = (int)(5 * Globals.Settings.Scale);
        cb.Location = new (line.Location.X + f, line.Location.Y - f, 0);
        line.Location = new(line.Location.X, line.Location.Y + cb.Size.Y + f, 0);
        Size = new(Size.X, Size.Y + cb.Size.Y + f);
    }
}